#include "stack_internal.h"





/****************************************************************************/
void stack_delete( void *stack_state, void (*user_data_delete_function)(void *user_data, void *user_state), void *user_state )
{
  struct stack_state
    *ss;

  void
    *user_data;

  assert( stack_state != NULL );
  // user_data_delete_function can be NULL
  // user_state can be NULL

  ss = (struct stack_state *) stack_state;

  while( stack_pop(stack_state, &user_data) )
    if( user_data_delete_function != NULL )
      user_data_delete_function( user_data, user_state );

  freelist_delete( ss->freelist_state, stack_internal_freelist_delete_function, NULL );

  abstraction_aligned_free( stack_state );

  return;
}





/****************************************************************************/
void stack_clear( void *stack_state, void (*user_data_clear_function)(void *user_data, void *user_state), void *user_state )
{
  struct stack_state
    *ss;

  void
    *user_data;

  assert( stack_state != NULL );
  // user_data_delete_function can be NULL
  // user_state can be NULL

  ss = (struct stack_state *) stack_state;

  while( stack_pop(stack_state, &user_data) )
    if( user_data_clear_function != NULL )
      user_data_clear_function( user_data, user_state );

  return;
}





/****************************************************************************/
#pragma warning( disable : 4100 )

void stack_internal_freelist_delete_function( void *user_data, void *user_state )
{
  assert( user_data != NULL );
  assert( user_state == NULL );

  abstraction_aligned_free( user_data );

  return;
}

#pragma warning( default : 4100 )

