/***** ANSI includes *****/
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/***** internal includes *****/
#include "abstraction.h"

/***** external includes *****/
#include "liblfds.h"

/***** defines *****/
#define and &&
#define or  ||

#define RAISED   1
#define LOWERED  0

#define NO_FLAGS 0x0

/***** prototypes *****/
int main( int argc, char **argv );

void freelist_test( void );
void queue_test( void );
void ringbuffer_test( void );
void stack_test( void );

thread_return_t freelist_internal_thread_freelist_writer( void *freelist_state );
thread_return_t freelist_internal_thread_freelist_reader( void *freelist_state );
thread_return_t freelist_internal_thread_freelist_reader_writer( void *freelist_state );

thread_return_t queue_internal_thread_reader( void *queue_state );
thread_return_t queue_internal_thread_writer( void *queue_state );

thread_return_t ringbuffer_internal_thread_reader( void *ringbuffer_state );
thread_return_t ringbuffer_internal_thread_writer( void *ringbuffer_state );

thread_return_t stack_internal_thread_reader( void *stack_state );
thread_return_t stack_internal_thread_writer( void *stack_state );

